part of datagrid;

/// A widget which displays in the header cells.
class GridHeaderCell extends GridCell {
  /// Creates the [GridHeaderCell] for [SfDataGrid] widget.
  const GridHeaderCell(
      {@required this.key,
      this.dataCell,
      this.padding,
      this.backgroundColor,
      this.isDirty,
      this.alignment,
      this.child})
      : super(
            key: key,
            child: child,
            dataCell: dataCell,
            padding: padding,
            alignment: alignment,
            backgroundColor: backgroundColor,
            isDirty: isDirty);

  /// Controls how one widget replaces another widget in the tree.
  final Key key;

  /// Holds the information required to display the cell.
  final DataCellBase dataCell;

  /// The [child] contained by the [GridHeaderCell].
  final Widget child;

  /// Empty space to inscribe inside the [GridHeaderCell].
  final EdgeInsets padding;

  /// The color to paint behind the [child].
  final Color backgroundColor;

  /// Decides whether the [GridHeaderCell] should be refreshed when [SfDataGrid]
  ///  is rebuild.
  final bool isDirty;

  /// Align the [child] within the GridHeaderCell.
  final Alignment alignment;
}
